DCMTK - Bug #1121

DCMTK will store uncompressed images of unknown transfer syntax as "Little Endian Explicit"
without any warning
Description

The test image attached to this issue (downloaded from https://github.com/chafey/DICOMHTJ2K/tree/main/test/fixtures/htj2k) is
invalid: it specifies the new HTJ2K transfer syntax but the pixel data is not encapsulated.

Surprisingly, dcmconv from DCMTK 3.6.8 release (which does not know this transfer syntax UID) will read the file and store it as
Explicit VR Little Endian without any warning:

> dcmconv CT1_JPH output.dcm

open input file CT1_JPH

load all data into memory

set output transfer syntax to input transfer syntax

check if new output transfer syntax is possible

output transfer syntax Little Endian Explicit can be written
create output file output.dcm

HH H H H H H

conversion successful

This probably happens because dcmdata sets the transfer syntax enum to "EXS_Unknown" while reading the file, which is the same
value that is also used when a new dataset is created in memory. DCMTK will then happily write that in any uncompressed transfer
syntax. This is undesirable. DCMTK should at least print a warning if the transfer syntax of a dataset is unknown after loading it from
file, and preferrably storing that file in uncompressed transfer syntax should be refused unless some override flag is set.

Note that this problem does not occur if the pixel data is encapsulated. In that case DCMTK detects that it is unable to properly
convert the file to an uncompressed transfer syntax and will refuse to write it.

Thanks to Peter Klotz <peter.klotz@siemens-healthineers.com> for the issue report (2024-04-16).

History

#1 - 2024-04-24 20:35 - J6rg Riesmeier

One approach to deal with this situation would be to introduce a new enum EXS_Unsupported that is used to distinguish unsupported Transfer
Syntaxes from datasets that are created in memory (which will keep using EXS_Unknown). For this new enum, DcmXfer could possibly also store the
original Transfer Syntax UID that was e.g. read from the File Meta Information (meta header).

#2 - 2024-06-26 10:05 - Jorg Riesmeier
- Category set to Library

- Target version set to 3.7.1+

#3 - 2025-01-23 13:18 - Jorg Riesmeier

- Target version changed from 3.7.1+ to 3.7.0

Files

CT1_JPH 184 KB 2024-04-18 Marco Eichelberg
